<?php

/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


// Import de Skyblog pour Dotclear
// Code: Copyleft (C) 2006 BohwaZ <bohwaz@tilt.eu.org>, licence GNU/GPL ww.gnu.org
// Icne: Copyleft (C) 2006 BohwaZ <bohwaz@tilt.eu.org>, licence Art Libre www.artlibre.org

function createImgDir()
{
    $imgdir = dirname(__FILE__).'/../../../images/skyblog';
    if(file_exists($imgdir) && is_dir($imgdir)) return $imgdir;
    if(@mkdir($imgdir)) return $imgdir;
    return false;
}

function dcSkyblogImageImport($img,$thumb="")
{
    $dir = createImgDir();
    if(!$dir) return false;
    if(!@copy($GLOBALS['import']->general['blogUrl'].'pics/'.$img,$dir.'/'.$img)) return false;
    if(!empty($thumb)) @copy($GLOBALS['import']->general['blogUrl'].'pics/'.$thumb,$dir.'/'.$thumb);
    return dc_img_url.'skyblog/';
}

function updateStatus($text,$level)
{
    $text = utf8_encode($text);
    if($level == "error") {
        buffer::str('<p style="color: red; border: 2px solid darkred; padding: 5px;"><strong>Erreur</strong>: '.$text.'</p>');
    }
    elseif($level == "warning") {
        buffer::str('<strong style="color: darkred; text-decoration: underline">Erreur</strong>: '.$text.'<br />');
    }
    else {
        buffer::str($text.'<br />');
    }
}


require_once('class.importSkyblog.php');
$import = new importSkyblog();
$import->imagesFunction = 'dcSkyblogImageImport';
$import->logFunction = 'updateStatus';
$import->replaceTags = array(
    '<strong>'=>'__', '</strong>'=>'__',
    '<em>'=>"''",'</em>'=>"''",
    '<br />'=>"\n",
    //'<span style="text-decoration: underline">([^<]+)</span>'=>'++\\1++',
    '<a [^>]*href="([^"]+)"[^>]*>([^<]+)</a>' => '[\\2|\\1]',
    'imageLeft'=>'((~IMAGE||L))',
    'imageRight'=>'((~IMAGE||R))',
    'imageCenter'=>'((~IMAGE))',
    'thumbLeft'=>'[((~THUMB||L))|~IMAGE]',
    'thumbRight'=>'[((~THUMB||R))|~IMAGE]',
    'thumbCenter'=>'[((~THUMB))|~IMAGE]'
);


// Rsum de l'import
if(!empty($_POST['resume']))
{
    $import->general = unserialize(base64_decode($_POST['general']));

    buffer::str(utf8_encode('
        <h2><img src="tools/importSkyblog/icon.png" style="float: left; margin-right: 5px" alt="" />
        Import de: '.$import->general['blogUrl'].'</h2><div style="clear: both">&nbsp;</div>'));

    buffer::str(utf8_encode('
    <h3>Import termin</h3>
    <p><strong style="color: darkgreen">L\'import s\'est bien droul.</strong>
        Voici un rsum du skyblog import.</p>

    <h3>On t imports:</h3>
    <ul>
      <li>'.$import->general['nb_articles'].' billets rpartis sur '.$import->general['total_pages'].' pages</li>
      <li>'.intval($import->general['nb_comments']).' commentaires (les commentaire taient '.
        ($import->general['comments'] ? 'activs' : 'dsactivs').')</li>
      <li>'.count($import->general['blogroll']).' liens dans la blogroll (skyblogs prfrs)</li>
      <li>'.$import->general['nb_images'].' images (copies dans le rpertoire "skyblog" de votre rpertoire images de dotclear)</li>
    </ul>

    <h3>Informations qui n\'ont pas t importes:</h3>
    <ul>
      <li><strong>Titre:</strong> '.htmlspecialchars($import->general['title']).'</li>
      <li><strong>Description:</strong> '.htmlspecialchars($import->general['description']).'</li>
      <li><strong>Date de cration:</strong> '.$import->general['creation'].'</li>
      <li><strong>Dernire modification:</strong> '.$import->general['updated'].'</li>
    </ul>'));
}

// Procdure d'import pour une page
elseif(!empty($_POST['skyblog']))
{
    if(!$_POST['general'])
    {
        $blogId = $_POST['skyblog'];
        $p = 1;
        $blog->addCat($_POST['category'],'','');
        $blog->resetError();
        $import->general['blogUrl'] = $import->getBlogUrl($blogId);
        $import->outputFormat = $_POST['format'];
    }
    else {
        $import->general = unserialize(base64_decode($_POST['general']));
        $import->outputFormat = $_POST['format'];
        $p = $_POST['page'];
    }

    buffer::str(utf8_encode('
        <h2><img src="tools/importSkyblog/icon.png" style="float: left; margin-right: 5px" alt="" />
        Import en cours de: '.$import->general['blogUrl'].'</h2><div style="clear: both">&nbsp;</div>'));

    if($_POST['general'])
    {
        buffer::str(utf8_encode('
            <h3>Import de la page '.$p.' (sur '.$import->general['total_pages'].' pages)</h3>
            <p>(Il y a '.$import->general['nb_articles'].' articles et '.intval($import->general['nb_comments']).' commentaires dans ce skyblog)</p>
            <div style="overflow: auto; height: 200px; font-size: 0.9em; border: 1px solid #999;">
            <div style="background: #999; color: #fff; padding: 2px">Debug:</div>'));

        $articles = $import->getPage($p);
        buffer::str('</div>');
    }
    else
    {
        buffer::str(utf8_encode('
            <h3>Import de la premire page</h3>
            <div style="overflow: auto; height: 200px; font-size: 0.9em; border: 1px solid #999;">
            <div style="background: #999; color: #fff; padding: 2px">Debug:</div>'));

        $articles = $import->getHome($blogId);
        buffer::str('</div>');


//print_r($articles);
#exit;
        if(is_array($articles))
        {
            require_once(dirname(__FILE__)."/../blogroll/class.blogroll.php");
            $blogroll = new blogroll($blog,DB_PREFIX);
            if(count($import->general['blogroll']) > 0)
            {
                foreach($import->general['blogroll'] as $item)
                    $blogroll->addLink(ucfirst(strtolower($item)),$import->getBlogUrl($item));
            }
        }
    }

    if(is_array($articles))
    {
        $cat = $blog->getCat($_POST['category']);
        $cat = $cat->f('cat_id');
        $user_id = $_SESSION['sess_user_id'];

        foreach($articles as $id=>$post)
        {
            $post_id = $blog->addPost($user_id, utf8_encode($post['title']),$blog->str2url(utf8_encode($post['title'])), '',
                utf8_encode($post['content']),'',$cat, $_POST['format'],true);
            if($post_id === false) updateStatus("Erreur pendant l'ajout du billet #$id ".$blog->error(1),'err');
            else
            {
                $date = date('Y-m-d H:i:s',$post['date']);
                $updReq = 'UPDATE '.$blog->t_post.' SET post_dt = \''.$date.'\', post_creadt=\''.$date.'\', post_upddt=\''.$date.
                    '\', nb_comment = \''.intval($import->general['comments_list'][$id]).'\' WHERE post_id = \''.$post_id.'\'';
                $blog->con->execute($updReq);

                foreach ($post['comments'] as $idc=>$comment)
                {
                    $comment['content'] = '<p>'.nl2br($comment['content']).'</p>';
                    $insReq = 'INSERT INTO '.$blog->t_comment.' (post_id,comment_dt,comment_upddt,comment_auteur,comment_email,'.
					'comment_site,comment_content,comment_ip,comment_pub,comment_trackback) VALUES '.
					'(\''.$post_id.'\', \''.date('Y-m-d H:i:s',$comment['date']).'\', SYSDATE(), \''.utf8_encode($blog->con->escapeStr($comment['name'])).'\', '.
					'\''.utf8_encode($blog->con->escapeStr($comment['email'])).'\', \'\', \''.utf8_encode($blog->con->escapeStr($comment['content'])).'\', '.
					'\'\', 1,'. (integer) false.') ';
                    if ($blog->con->execute($insReq) === false)
                        updateStatus("Erreur pendant l'ajout du commentaire #$idc du billet #$id",'err');
				}
			}
            $blog->resetError();
        }

        if($p <= $import->general['total_pages'])
        {
            buffer::str('
            <form method="post" id="nextPage" onsubmit="ShowLoading()">
            <input type="hidden" name="general" value="'.base64_encode(serialize($import->general)).'" />
            <input type="hidden" name="skyblog" value="'.$import->general['blogId'].'" />
            <input type="hidden" name="page" value="'.($p+1).'" />
            <input type="hidden" name="category" value="'.$_POST['category'].'" />
            <input type="hidden" name="format" value="'.$_POST['format'].'" />');

            if($p == $import->general['total_pages'])
                buffer::str(utf8_encode('<p><strong style="color: darkgreen">Import termin!</strong>
                <input type="hidden" name="resume" value="yes" /><input type="submit" value="Rsum de l\'import" id="fbtn" /></p>'));
            else
                buffer::str(utf8_encode('<p>Cliquez sur ce bouton pour continuer: <input type="submit" value="Page suivante" id="fbtn" /> (ou attendez 5 secondes)</p>'));

            buffer::str('
            <script type="text/javascript">
            document.write(\'<p id="loading" style="border: 2px solid darkblue; padding: 5px; visibility: hidden;">Patientez, import en cours... <img src="tools/importSkyblog/loading.gif" alt="" /></p>\');
            function ShowLoading() { document.getElementById("fbtn").disabled = true; document.getElementById("loading").style.visibility = "visible"; }
            function Redirect() { document.getElementById("nextPage").submit(); ShowLoading(); } setTimeout("Redirect()",5000); </script>
            </form>');
        }
        else
            buffer::str(utf8_encode('<p><strong style="color: darkgreen">Import termin!</strong></p>'));
    }
}
else
{
    $heure = date('H');
    if($heure < 23 && $heure > 10 && empty($_GET['force']))
    {
        buffer::str(utf8_encode('
        <h2><img src="tools/importSkyblog/icon.png" style="float: left; margin-right: 5px" alt="" />
        Import de Skyblog</h2><div style="clear: both">&nbsp;</div>

        <p>Il est '.$heure.'h'.date('i').', hors il est possible que l\'import fonctionne mal  cette heure
            (skyblog tant surcharg la journe), voire que l\'IP de votre serveur soit bannie de skyblog.com.</p>
        <p>Il est conseill de procder  l\'import entre 23h et 10h du matin, lorsque skyblog n\'est pas surcharg.</p>
        <p><a href="?p=importSkyblog&amp;force=yes">Forcer l\'import quand mme</a> (dconseill)</p>'));
    }
    else
    {
        buffer::str(utf8_encode('
        <h2><img src="tools/importSkyblog/icon.png" style="float: left; margin-right: 5px" alt="" />
        Import de Skyblog</h2><div style="clear: both">&nbsp;</div>

        <form method="post" onsubmit="ShowLoading();">
        <dl>
            <dt><strong><label for="fsky">Adresse du skyblog:</label></strong><dt>
            <dd>http://<input type="text" name="skyblog" id="fsky" />.skyblog.com/</dd>
            <dt><strong>Importer les billets au format:</strong></dt>
            <dd>
                <label for="fwiki" style="display: inline; text-decoration: underline;"><input type="radio" name="format" value="wiki" id="fwiki" checked="checked" /> Wiki</label> (les couleurs et autres artefacts seront supprims)<br />
                <label for="fhtml" style="display: inline; text-decoration: underline;"><input type="radio" name="format" value="html" id="fhtml" /> HTML</label> (toute la mise en forme sera conserve mais il sera plus difficile de modifier les billets)
            </dd>
            <dt><strong>Importer les billets dans cette catgorie:</strong></dt>
            <dd><input type="text" name="category" value="Skyblog" /> (elle sera cre si elle n\'existe pas)</dd>
        </dl>
        <p><input type="submit" value="Importer" id="fbtn" /> </p>
        <script type="text/javascript">
        document.write(\'<p id="loading" style="border: 2px solid darkblue; padding: 5px; visibility: hidden;">Patientez, import en cours... <img src="tools/importSkyblog/loading.gif" alt="" /></p>\');
        function ShowLoading() { document.getElementById("fbtn").disabled = true; document.getElementById("loading").style.visibility = "visible"; }
        </script></form>'));
    }
}

?>
